package com.engine.jclproduct.entity.bo;

import cn.hutool.core.collection.CollectionUtil;
import com.engine.jclproduct.entity.po.*;
import com.engine.jclproduct.utils.EmploymentUtil;
import weaver.common.DateUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Author liang.cheng
 * @Date 2024/10/22 5:31 PM
 * @Description: TODO
 * @Version 1.0
 */
public class EmploymentRecordBo {


    public static List<EmploymentRecordPo> buildEmploymentRecordPo(List<HrmresourcePo> hrmresourcePos) {
        List<EmploymentRecordPo> employmentRecordPos = new ArrayList<>();
        if (CollectionUtil.isEmpty(hrmresourcePos)) {
            return employmentRecordPos;
        }
        String currentDate = DateUtil.getCurrentDate();
        //失效日期默认最大值
        return hrmresourcePos.stream().map(e-> {
            Map<String, Integer> map = EmploymentUtil.dateSplitExample(e.getCompanyStartDate());
            return EmploymentRecordPo.builder()
                    .userId(e.getUserId())
                    .workcode(e.getWorkcode())
                    .employeeStatus(e.getStatus())
                    .changType(EmploymentUtil.getChangeType(e.getStatus()))
                    .startDate("".equals(e.getCompanyStartDate())?currentDate:e.getCompanyStartDate())
                    .stopDate("9999-12-31") //失效日期默认最大值
                    .departmentId(e.getDepartmentId())
                    .subCompanyId(e.getSubcompanyId())
                    .superior(e.getManagerId())
                    .position(e.getJobTitle())
                    .companyStartDate(e.getCompanyStartDate())
                    .workyear(e.getCompanyWorkyear())
                    .entryDateYear(map.get("year"))
                    .entryDateMonth(map.get("month"))
                    .entryDateDay(map.get("day"))
                    .sex(e.getSex())
                    .birthday(e.getBirthday())
                    .build();}
        ).collect(Collectors.toList());
    }

    public static List<OrganizationRecordPo> buildOrganizationRecordPo(List<SubCompanyPo> subCompanyPos, List<DepartmentPo> departmentPos) {
        List<OrganizationRecordPo> organizationRecordPos = new ArrayList<>();

        if (CollectionUtil.isNotEmpty(subCompanyPos)){
           subCompanyPos.forEach(e -> organizationRecordPos.add(setOrganizationRecordPo(e,null,0)));
        }

        if (CollectionUtil.isNotEmpty(departmentPos)) {
            departmentPos.forEach(e -> organizationRecordPos.add(setOrganizationRecordPo(null,e,1)));
        }

        return organizationRecordPos;
    }


    public static  OrganizationRecordPo setOrganizationRecordPo(SubCompanyPo sub,DepartmentPo dept,Integer type) {
        String currentDate = DateUtil.getCurrentDate();
        if (type == 0) {
            return OrganizationRecordPo.builder()
                    .orgStatus(sub.getCanceled() == 1 ? 1 : 0)
                    .startDate(currentDate)
                    .stopDate("9999-12-31")
                    .oId(sub.getSubcompanyId())
                    .oType(0)
                    .oName(sub.getSubcompanyName())
                    .oParentId(sub.getSupsubcomId())
                    .changeType(sub.getCanceled() == 1 ? 2 : 0)
                    .showorder(sub.getShoworder())
                    .organizationCode(sub.getSubcompanyCode())
                    .build();
        }else {
            return OrganizationRecordPo.builder()
                    .orgStatus(dept.getCanceled() == 1 ? 1 : 0)
                    .startDate(currentDate)
                    .stopDate("9999-12-31")
                    .oId(dept.getDepartmentId())
                    .oType(1)
                    .oName(dept.getDepartmentmark())
                    .oParentId(dept.getSupdepId())
                    .oChargeId(dept.getBmfzr())
                    .changeType(dept.getCanceled() == 1 ? 2 : 0)
                    .showorder(dept.getShoworder())
                    .organizationCode(dept.getDepartmentCode())
                    .belongSub(dept.getSubcompanyId())
                    .build();
        }

    }

    public static EmploymentRecordPo setEmploymentRecordPo(HrmresourcePo h){
        Map<String, Integer> map = EmploymentUtil.dateSplitExample(h.getCompanyStartDate());

        //处理其他参数
        return EmploymentRecordPo.builder()
                .userId(h.getUserId())
                .workcode(h.getWorkcode())
                .employeeStatus(h.getStatus())
                .changType(EmploymentUtil.getChangeType(h.getStatus()))
                .startDate(DateUtil.getCurrentDate())
                .stopDate("9999-12-31")
                .departmentId(h.getDepartmentId())
                .subCompanyId(h.getSubcompanyId())
                .superior(h.getManagerId())
                .position(h.getJobTitle())
                .companyStartDate(h.getCompanyStartDate())
                .workyear(h.getCompanyWorkyear())
                .entryDateYear(map.get("year"))
                .entryDateMonth(map.get("month"))
                .entryDateDay(map.get("day"))
                .sex(h.getSex())
                .birthday(h.getBirthday())
                .build();
    }
}
