package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "195fd81d-95fb-4568-af05-1a564c863e21",
        fields = "t.id," +
                "t.orgStatus," +
                "t.organizationCode," +
                "t.oName," +
                "t.oParentId," +
                "t.oChargeId," +
                "t.belongSub," +
                "t.showorder",
        fromSql = "FROM uf_orgChange t",
        orderby = "showorder",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TimeDepartmentVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "orgStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexOrgStatus")
    private String orgStatus;

    /**
     * 部门编码
     */
    @WeaverTableColumn( text = "部门编码", width = "10%", column = "organizationCode")
    private String organizationCode;

    /**
     * 部门名称
     */
    @WeaverTableColumn( text = "部门名称", width = "10%", column = "oName")
    private String oName;

    /**
     * 上级部门
     */
    @WeaverTableColumn( text = "上级部门", width = "10%", column = "oParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String oParentId;


    /**
     * 部门负责人
     */
    @WeaverTableColumn( text = "部门负责人", width = "10%", column = "oChargeId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private String oChargeId;

    /**
     * 所属分部
     */
    @WeaverTableColumn( text = "所属分部", width = "10%", column = "belongSub",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String belongSub;

    /**
     * 显示顺序
     */
    @WeaverTableColumn( text = "显示顺序", width = "10%", column = "showorder")
    private String showorder;




}
