package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "6f201832-a940-4225-a4c9-3f4b96ff5b89",
        fields = "t.id," +
                "t.startDate," +
                "t.stopDate," +
                "t.userId," +
                "t.workcode," +
                "t.employeeStatus," +
                "t.subCompanyId," +
                "t.departmentId," +
                "t.position," +
                "t.superior," +
                "t.companyStartDate," +
                "t.expectedLastWorkDate," +
                "t.lastWorkDate," +
                "t.probationActualStopDate," +
                "t.regularizationDate," +
                "t.workyear," +
                "t.sex," +
                "t.birthday",
        fromSql = "FROM uf_EmploymentRecord t ",
        orderby = "userid",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TimeResourceVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    @WeaverTableColumn(column = "startDate",text = "生效日期", display = false)
    private String startDate;

    @WeaverTableColumn(column = "stopDate",text = "失效日期", display = false)
    private String stopDate;

    /**
     * 姓名
     */
    @WeaverTableColumn( text = "姓名", width = "10%", column = "userId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private String userId;
    /**
     * 工号
     */
    @WeaverTableColumn( text = "工号", width = "10%", column = "workcode")
    private String workcode;
    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "employeeStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.statusName")
    private String employeeStatus;

    /**
     * 分部
     */
    @WeaverTableColumn( text = "分部", width = "10%", column = "subCompanyId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String subCompanyId;
    /**
     * 部门
     */
    @WeaverTableColumn( text = "部门", width = "10%", column = "departmentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String departmentId;
    /**
     * 岗位
     */
    @WeaverTableColumn( text = "岗位", width = "10%", column = "position",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.jobTitleName")
    private String position;
    /**
     * 直接上级
     */
    @WeaverTableColumn( text = "直接上级", width = "10%", column = "superior",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private Integer superior;
    /**
     * 入职日期
     */
    @WeaverTableColumn( text = "入职日期", width = "10%", column = "companyStartDate")
    private Integer companyStartDate;
    /**
     * 退休日期
     */
    @WeaverTableColumn( text = "退休日期", width = "10%", column = "expectedLastWorkDate")
    private Integer expectedLastWorkDate;
    /**
     * 离职日期
     */
    @WeaverTableColumn( text = "离职日期", width = "10%", column = "lastWorkDate")
    private Integer lastWorkDate;
    /**
     * 转正日期
     */
    @WeaverTableColumn( text = "转正日期", width = "10%", column = "regularizationDate")
    private Integer regularizationDate;
    /**
     * 司龄
     */
//    @WeaverTableColumn( text = "司龄", width = "10%", column = "workyear")
//    private Integer workyear;
    /**
     * 性别
     */
    @WeaverTableColumn( text = "性别", width = "10%", column = "sex",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexName")
    private String sex;
    /**
     * 生日
     */
    @WeaverTableColumn( text = "生日", width = "10%", column = "birthday")
    private String birthday;




}
