package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "ab83519e-1df8-48a0-9c4b-4ba60aa69c5e",
        fields = "t.id," +
                "t.orgStatus," +
                "t.organizationCode," +
                "t.oName," +
                "t.oParentId," +
                "t.showorder",
        fromSql = "FROM uf_orgChange t",
        orderby = "showorder",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TimeSubCompanyVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "orgStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexOrgStatus")
    private String orgStatus;

    /**
     * 分部编码
     */
    @WeaverTableColumn( text = "分部编码", width = "10%", column = "organizationCode")
    private String organizationCode;

    /**
     * 分部名称
     */
    @WeaverTableColumn( text = "分部名称", width = "10%", column = "oName")
    private String oName;

    /**
     * 上级分部
     */
    @WeaverTableColumn( text = "上级分部", width = "10%", column = "oParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String oParentId;

    /**
     * 显示顺序
     */
    @WeaverTableColumn( text = "显示顺序", width = "10%", column = "showorder")
    private String showorder;




}
