package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "4e0e4e0b-2440-4446-a9c6-e7fd44301bf7",
        fields = "t.id," +
                "t.orgStatus," +
                "t.oName," +
                "t.belongSub," +
                "t.oldName," +
                "t.oldOChargeId," +
                "t.newName," +
                "t.newParentId," +
                "t.newOChargeId," +
                "t.showorder",
        fromSql = "FROM uf_orgChange t",
        orderby = "showorder",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TransDepartmentVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "orgStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexOrgStatus")
    private String orgStatus;


    /**
     * 部门名称
     */
    @WeaverTableColumn( text = "部门名称", width = "10%", column = "oName")
    private String oName;

    /**
     * 所属分部
     */
    @WeaverTableColumn( text = "所属分部", width = "10%", column = "belongSub",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String belongSub;

    /**
     * 变动前部门名称
     */
    @WeaverTableColumn( text = "变动前部门名称", width = "10%", column = "oldName")
    private String oldName;

    /**
     * 变动前上级部门
     */
    @WeaverTableColumn( text = "变动前上级部门", width = "10%", column = "oldParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String oldParentId;

    /**
     * 变动前部门负责人
     */
    @WeaverTableColumn( text = "变动前部门负责人", width = "10%", column = "oldOChargeId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private String oldOChargeId;

    /**
     * 变动后部门名称
     */
    @WeaverTableColumn( text = "变动后部门名称", width = "10%", column = "newName")
    private String newName;

    /**
     * 变动后上级部门
     */
    @WeaverTableColumn( text = "变动后上级部门", width = "10%", column = "newParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String newParentId;

    /**
     * 变动后部门负责人
     */
    @WeaverTableColumn( text = "变动后部门负责人", width = "10%", column = "newOChargeId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private String newOChargeId;



}
