package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "f3fbe166-778d-4ed7-b026-528c3262fa48",
        fields = "t.id," +
                "t.orgStatus," +
                "t.oName," +
                "t.oldName," +
                "t.oldParentId," +
                "t.newName," +
                "t.newParentId",
        fromSql = "FROM uf_orgChange t",
        orderby = "showorder",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TransSubCompanyVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;

    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "5%", column = "orgStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexOrgStatus")
    private String orgStatus;


    /**
     * 分部名称
     */
    @WeaverTableColumn( text = "分部名称", width = "10%", column = "oName")
    private String oName;

    /**
     * 变动前分部名称
     */
    @WeaverTableColumn( text = "变动前分部名称", width = "10%", column = "oldName")
    private String oldName;

    /**
     * 变动前上级分部
     */
    @WeaverTableColumn( text = "变动前上级分部", width = "10%", column = "oldParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String oldParentId;


    /**
     * 变动后分部名称
     */
    @WeaverTableColumn( text = "变动后分部名称", width = "10%", column = "newName")
    private String newName;

    /**
     * 变动后上级分部
     */
    @WeaverTableColumn( text = "变动后上级分部", width = "10%", column = "newParentId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String newParentId;



}
