package com.engine.jclproduct.entity.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.jclproduct.annotation.WeaverTable;
import com.engine.jclproduct.annotation.WeaverTableColumn;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:22 PM
 * @Description:
 * @Version 1.0
 */

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@WeaverTable(pageId = "ba7d8752-a037-4b1a-b1dc-7361f78f0683",
        fields = "t.id," +
                "t.startDate," +
                "t.stopDate," +
                "t.userId," +
                "t.workcode," +
                "t.employeeStatus," +
                "t.subCompanyId," +
                "t.changeNewDept," +
                "t.changeNewJob," +
                "t.changeNewSuperior," +
                "t.changeOldDept," +
                "t.changeOldJob," +
                "t.changeOldSuperior," +
                "t.companyStartDate," +
                "t.lastWorkDate," +
                "t.workyear," +
                "t.sex," +
                "t.birthday",
        fromSql = "FROM uf_EmploymentRecord t ",
        orderby = "userid",
        sortway = "asc",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class TransferResourceVo {

    /**
     * 主键
     */
    @WeaverTableColumn(column = "id",text = "序号", display = false)
    private Integer id;



    @WeaverTableColumn(column = "startDate",width = "10%",text = "调动日期")
    private String startDate;

    @WeaverTableColumn(column = "stopDate",width = "10%",text = "失效日期", display = false)
    private String stopDate;
    /**
     * 姓名
     */
    @WeaverTableColumn( text = "姓名", width = "10%", column = "userId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private String userId;
    /**
     * 工号
     */
    @WeaverTableColumn( text = "工号", width = "10%", column = "workcode")
    private String workcode;
    /**
     * 状态
     */
    @WeaverTableColumn( text = "状态", width = "10%", column = "employeeStatus",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.statusName")
    private String employeeStatus;

    /**
     * 分部
     */
    @WeaverTableColumn( text = "分部", width = "10%", column = "subCompanyId",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.subCompanyName")
    private String subCompanyId;
    /**
     * 新部门
     */
    @WeaverTableColumn( text = "新部门", width = "10%", column = "changeNewDept",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String changeNewDept;
    /**
     * 新岗位
     */
    @WeaverTableColumn( text = "新岗位", width = "10%", column = "changeNewJob",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.jobTitleName")
    private String changeNewJob;
    /**
     * 新直接上级
     */
    @WeaverTableColumn( text = "新直接上级", width = "10%", column = "changeNewSuperior",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private Integer changeNewSuperior;
    /**
     * 原部门
     */
    @WeaverTableColumn( text = "原部门", width = "10%", column = "changeOldDept",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.departmentName")
    private String changeOldDept;
    /**
     * 原岗位
     */
    @WeaverTableColumn( text = "原岗位", width = "10%", column = "changeOldJob",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.jobTitleName")
    private String changeOldJob;
    /**
     * 原直接上级
     */
    @WeaverTableColumn( text = "原直接上级", width = "10%", column = "changeOldSuperior",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.resourceName")
    private Integer changeOldSuperior;
    /**
     * 入职日期
     */
    @WeaverTableColumn( text = "入职日期", width = "10%", column = "companyStartDate")
    private Integer companyStartDate;

    /**
     * 离职日期
     */
    @WeaverTableColumn( text = "离职日期", width = "10%", column = "lastWorkDate")
    private Integer lastWorkDate;

    /**
     * 司龄
     */
//    @WeaverTableColumn( text = "司龄", width = "10%", column = "workyear")
//    private Integer workyear;
    /**
     * 性别
     */
    @WeaverTableColumn( text = "性别", width = "10%", column = "sex",transmethod = "com.engine.jclproduct.transmethod.EmReportTransMethod.sexName")
    private String sex;



}
