package com.engine.jclproduct.service;

import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 11:10 AM
 * @Description: TODO
 * @Version 1.0
 */
public interface EmployeeRecordReportService {

    /**
     * @Description: 人事花名册（总）
     * @Author: liang.cheng
     * @Date: 2024/10/25 2:19 PM
     * @param: [params]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String,Object> commonReport(Map<String, Object> params);



    /**
     * @Description: 时点花名册
     * @Author: liang.cheng
     * @Date: 2024/10/25 2:21 PM
     * @param: []
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, Object> timeResourece(Map<String, Object> params);


    /**
     * @Description: 离职员工花名册
     * @Author: liang.cheng
     * @Date: 2024/10/25 2:21 PM
     * @param: []
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, Object> leaveResourece(Map<String, Object> params);



    /**
     * @Description: 人员调动记录
     * @Author: liang.cheng
     * @Date: 2024/10/25 2:21 PM
     * @param: []
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, Object> transferResourece(Map<String, Object> params);



    /**
     * @Description: 管理幅度统计
     * @Author: liang.cheng
     * @Date: 2024/10/25 2:21 PM
     * @param: []
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, Object> caluResourece(Map<String, Object> params);


    /**
     * @Description: 管理幅度统计导出
     * @Author: liang.cheng
     * @Date: 2024/11/1 11:42 AM
     * @param: [request, response]
     * @return: org.apache.poi.xssf.usermodel.XSSFWorkbook
     */
    XSSFWorkbook reportExport(Map<String, Object> params);

    /**
     * @Description: 组织（总）
     * @Author: liang.cheng
     * @Date: 2024/11/8 4:16 PM
     * @param: [params]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String,Object> orgReport(Map<String, Object> params);
}
