package com.engine.jclproduct.service.impl;

import com.engine.core.impl.Service;
import com.engine.jclproduct.entity.bo.EmploymentRecordBo;
import com.engine.jclproduct.entity.po.*;
import com.engine.jclproduct.service.EmploymentRecordService;
import com.engine.jclproduct.utils.EmploymentUtil;
import com.weaver.file.ConfigOperator;
import com.weaver.general.BaseBean;
import com.weaver.general.TimeUtil;
import com.weaver.general.Util;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/10/22 4:23 PM
 * @Description: TODO
 * @Version 1.0
 */
public class EmploymentRecordServiceImpl extends Service implements EmploymentRecordService {


    @Override
    public Map<String, Object> initPerson() {

        Map<String, Object> map = new HashMap<>();
        //1.任职记录表初始化数据 只执行一次
        RecordSet rs = new RecordSet();
        rs.executeQuery("select count(1) as num from uf_EmploymentRecord");
        rs.next();
        int num = Util.getIntValue(rs.getString("num"));
        if (num > 0) {
            map.put("msg","员工任职记录表已经初始化，不可重复执行");
            return map;
        }

        //2.获取当前人员表人员信息
        List<HrmresourcePo> hrmresourcePoList = EmploymentUtil.getHrmResources();

        hrmresourcePoList.forEach(e-> rs.executeUpdate("insert into uf_hrmresource_day(userId,workcode,companystartdate,companyworkyear," +
                " birthday,jobtitle,departmentid,subcompanyid,managerid,status,sex) values(?,?,?,?,?,?,?,?,?,?,?)",e.getUserId(),e.getWorkcode(),
                e.getCompanyStartDate(),e.getCompanyWorkyear(),e.getBirthday(),e.getJobTitle(),e.getDepartmentId(),e.getSubcompanyId(),e.getManagerId(),e.getStatus(),e.getSex()));

        map.put("msg1","人力资源中间表初始化完成，当前共"+hrmresourcePoList.size()+"条数据");

        List<EmploymentRecordPo> employmentPos = EmploymentRecordBo.buildEmploymentRecordPo(hrmresourcePoList);
        BaseBean bb = new BaseBean();
        String formModeId = bb.getPropValue("jclproduct", "eModeId");

        String modeDataCreateDate = DateUtil.getCurrentDate();
        String modeDataCreateTime = TimeUtil.getOnlyCurrentTimeString();
        ConfigOperator configOperator = new ConfigOperator();
        configOperator.setProp("jclproduct.properties", "startDate", modeDataCreateDate);

        employmentPos.forEach(e-> rs.executeUpdate("insert into uf_EmploymentRecord(userId,workcode,employeeStatus,changType,startDate,stopDate," +
                " departmentId,subCompanyId,superior,position,companyStartDate,workyear,entryDateYear,entryDateMonth,entryDateDay," +
                " sex,birthday,formmodeid,modeDataCreateDate,modeDataCreateTime,modeDataCreater) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)",
                e.getUserId(),e.getWorkcode(),e.getEmployeeStatus(),e.getChangType(),e.getStartDate(),e.getStopDate(),e.getDepartmentId(),
                e.getSubCompanyId(),e.getSuperior(),e.getPosition(),e.getCompanyStartDate(),e.getWorkyear(),e.getEntryDateYear(),e.getEntryDateMonth(),
                e.getEntryDateDay(),e.getSex(),e.getBirthday(),formModeId,modeDataCreateDate,modeDataCreateTime,1));

        map.put("msg2","员工任职记录表初始化完成，人力资源表共"+employmentPos.size()+"条数据");
        return map;
    }

    @Override
    public Map<String, Object> initOrganization() {
        Map<String, Object> map = new HashMap<>(8);
        //1.任职记录表初始化数据 只执行一次
        RecordSet rs = new RecordSet();
        rs.executeQuery("select count(1) as num from uf_orgChange");
        rs.next();
        int num = Util.getIntValue(rs.getString("num"));
        if (num > 0) {
            map.put("msg","组织变更记录表已经初始化，不可重复执行");
            return map;
        }

        //1.人力资源分部中间表
        List<SubCompanyPo> subCompany = EmploymentUtil.getSubCompany();
        subCompany.forEach(e -> rs.executeUpdate("insert into uf_hrmsubcompany(subcompanyId,subcompanyName,companyId,supsubcomId,showorder,canceled,subcompanyCode) values(?,?,?,?,?,?,?)",e.getSubcompanyId(),
                e.getSubcompanyName(),e.getCompanyId(),e.getSupsubcomId(),e.getShoworder(),e.getCanceled(),e.getSubcompanyCode()));
        map.put("msg1","人力资源分部中间表初始化完成，共"+subCompany.size()+"条数据");

        //2.人力资源部门中间表
        List<DepartmentPo> department = EmploymentUtil.getDepartment();
        department.forEach(e -> rs.executeUpdate("insert into uf_hrmdepartment(departmentId,departmentmark,subcompanyId,supdepId,showorder,canceled,departmentCode,bmfzr) values(?,?,?,?,?,?,?,?)",e.getDepartmentId(),
                e.getDepartmentmark(),e.getSubcompanyId(),e.getSupdepId(),e.getShoworder(),e.getCanceled(),e.getDepartmentCode(),e.getBmfzr()));

        map.put("msg2","人力资源部门中间表初始化完成，共"+department.size()+"条数据");

        //3.组织变更记录表
        List<OrganizationRecordPo> organizationRecordPos = EmploymentRecordBo.buildOrganizationRecordPo(subCompany, department);
        organizationRecordPos.forEach(e -> rs.executeUpdate("insert into uf_orgChange(orgStatus,startDate,stopDate,oId,oType,oName,oParentId,oChargeId,changeType,showorder,organizationCode,belongSub) values(?,?,?,?,?,?,?,?,?,?,?,?)",e.getOrgStatus(),
                e.getStartDate(),e.getStopDate(),e.getOId(),e.getOType(),e.getOName(),e.getOParentId(),e.getOChargeId(),e.getChangeType(),e.getShoworder(),e.getOrganizationCode(),e.getBelongSub()));


        map.put("msg3","组织变更记录表初始化完成，共"+organizationRecordPos.size()+"条数据");

        return map;
    }


}
