package com.engine.jclproduct.transmethod;


import cn.hutool.core.collection.CollectionUtil;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.company.SubCompanyComInfo;
import weaver.hrm.job.JobTitlesComInfo;
import weaver.hrm.resource.ResourceComInfo;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author liang.cheng
 * @Date 2024/10/25 2:34 PM
 * @Description:
 * @Version 1.0
 */
public class EmReportTransMethod {

    public static String subCompanyName(String id) {
        SubCompanyComInfo subCompanyComInfo = new SubCompanyComInfo();
        return subCompanyComInfo.getSubCompanyname(id);
    }

    public static String departmentName(String id) {
        DepartmentComInfo departmentComInfo = new DepartmentComInfo();
        try {
            return departmentComInfo.getDepartmentName(id);
        } catch (Exception e) {
            return "";
        }
    }

    public static String jobTitleName(String id) {
        JobTitlesComInfo jobTitlesComInfo = new JobTitlesComInfo();
        return jobTitlesComInfo.getJobTitlesname(id);
    }

    public static String resourceName(String id) {
        try {
            List<String> ids = Arrays.stream(id.split(","))
                    .map(String::valueOf)
                    .collect(Collectors.toList());
            ResourceComInfo resourceComInfo = new ResourceComInfo();
            List<String> names = ids.stream()
                    .map(resourceComInfo::getLastname)
                    .collect(Collectors.toList());
            return CollectionUtil.join(names,",");
        } catch (Exception e) {
            return "";
        }
    }

    public static String sexName(String id) {
        return "1".equals(id) ? "女":"男";
    }

    public static String statusName(String id) {
        String name = "";
        switch (id){
            case "0":
                name = "试用";
                break;
            case "1":
                name = "正式";
                break;
            case "2":
                name = "临时";
                break;
            case "3":
                name = "试用延期";
                break;
            case "4":
                name = "解聘";
                break;
            case "5":
                name = "离职";
                break;
            case "6":
                name = "退休";
                break;
            case "7":
                name = "无效";
                break;
            default:
                break;
        }
        return name;
    }


    public static String sexOrgStatus(String id) {
        return "1".equals(id) ? "封存":"启用";
    }


}
