package com.engine.jclproduct.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ServiceUtil;
import com.engine.jclproduct.service.EmploymentRecordService;
import com.engine.jclproduct.service.impl.EmploymentRecordServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/10/22 4:22 PM
 * @Description: TODO
 * @Version 1.0
 */
public class EmploymentRecordAction {

    private EmploymentRecordService getService(User user) {
        return  ServiceUtil.getService(EmploymentRecordServiceImpl.class, user);
    }


    @GET
    @Path("/initPerson")
    @Produces(MediaType.TEXT_PLAIN)
    public String initPerson(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).initPerson());
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }

    @GET
    @Path("/initOrganization")
    @Produces(MediaType.TEXT_PLAIN)
    public String initOrganization(@Context HttpServletRequest request, @Context HttpServletResponse response){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("datas",getService(user).initOrganization());
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
