package com.engine.wysecond.entity.resume;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import net.coobird.thumbnailator.Thumbnails;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.util.IOUtils;
import weaver.file.ImageFileManager;
import weaver.general.GCONST;
import weaver.general.Util;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.util.Base64;

/**
 * @Author liang.cheng
 * @Date 2025/2/17 14:56
 * @Description:
 * @Version 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class PersonnelResumePo {

    private Integer id;
    private String workcode;
    private String lastName;
    private String sex;
    private String birthday;
    private String resourceImageId;
    private String policy;

    private String nation;
    private String nativePlace;
    private String companyStartDate;
    private String joinPartyDate;
    private String workStartDate;
    private String highPersonType;
    private String jobCall;
    private String department;
    private String jobTitle;
    private String postionLevel;
    private String position;

    private String fullHighEducational;
    private String fullHighMajor;
    private String fullHighSchool;
    private String fullHighDegree;


    private String notfullHighEducational;
    private String notfullHighMajor;
    private String notfullHighSchool;
    private String notfullHighDegree;


    public String getSex() {
        if ("1".equals(sex)) {
            return "女";
        }
        return "男";
    }

    public String getImage() {
        if (StringUtils.isBlank(resourceImageId)) {
            return "";
        }
        ImageFileManager manager = new ImageFileManager();
        manager.getImageFileInfoById(Util.getIntValue(resourceImageId));
        InputStream inputStream = manager.getInputStream();
        String imageStr = "";
        try {
            String outPutPath = GCONST.getRootPath() + "hrm" + File.separator + "import" + File.separator + "template" + File.separator
                    + manager.getImageFileName();

            File f = new File(outPutPath);
            if (!f.exists()) {
                String substring = outPutPath.substring(0, outPutPath.lastIndexOf(File.separator));
                File file = new File(substring);
                if (file.mkdirs()) {
                    boolean newFile = f.createNewFile();
                    if (!newFile) {
                        throw new IOException(outPutPath + "文件创建失败");
                    }
                }
            }
            Thumbnails.of(inputStream).forceSize(100, 120).toFile(f);
            try (InputStream fileInputStream = Files.newInputStream(f.toPath())) { // 使用 try-with-resources 确保 fileInputStream 关闭
                imageStr = "data:image/" + manager.getImageFileType() + ";base64," + Base64.getEncoder().encodeToString(IOUtils.toByteArray(fileInputStream));
            }
            // 删除文件
            f.delete();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return imageStr;
    }

    public String getBirthday() {
        if (StringUtils.isBlank(birthday)) {
            return "";
        }else {
            return birthday.substring(0,7);
        }
    }



}
