package com.engine.wysecond.service;



import com.engine.wysecond.entity.resume.PersonnelResumePo;
import com.engine.wysecond.entity.resume.PersonnelResumeTable;

import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/2/17 14:41
 * @Description:
 * @Version 1.0
 */
public interface PersonnelResumeService {

    /**
     * @Description: 人员简历
     * @Author: liang.cheng
     * @Date: 2025/2/17 14:53
     * @param: [resourceId]
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    Map<String, Object> getResumeList(String resourceId);



    /**
     * @Description: 根据人员id获取主表信息
     * @Author: liang.cheng
     * @Date: 2025/2/18 10:43
     * @param: [resourceId]
     * @return: com.engine.shkjsecond.entity.PersonnelResumePo
     */
    PersonnelResumePo peopleMainInfo(String resourceId);

    /**
     * 根据人员id获取明细表信息
     * @param resourceId
     * @return
     */
    List<PersonnelResumeTable> peopleDetailInfo(String resourceId);
}
