package com.engine.wysecond.service;

import com.engine.wysecond.entity.PostionMatrixVo;
import com.engine.wysecond.entity.ResourcesPo;

import java.util.List;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/2/26 10:03
 * @Description:
 * @Version 1.0
 */
public interface PostionMatrixService {

    /**
     * @Description: 岗位矩阵图
     * @Author: liang.cheng
     * @Date: 2025/2/26 10:09
     * @param: []
     * @return: java.util.Map<java.lang.String,java.lang.Object>
     */
    PostionMatrixVo postionMatrix();


    /** 建模人员业务职务信息
     * @Description:
     * @Author: liang.cheng
     * @Date: 2025/2/28 16:41
     * @param: []
     * @return: java.util.List<com.engine.wysecond.entity.ResourcesPo>
     */
    List<ResourcesPo> postionPeoples();


    /**
     * @Description: 按照起始时间过滤
     * @Author: liang.cheng
     * @Date: 2025/3/3 10:42
     * @param: [resourcesPos]
     * @return: java.util.List<com.engine.wysecond.entity.ResourcesPo>
     */
    List<ResourcesPo> filterClosestWorkDate(List<ResourcesPo> resourcesPos);
}
