package com.engine.wysecond.web;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.engine.common.util.ServiceUtil;
import com.engine.wysecond.service.PersonnelResumeService;
import com.engine.wysecond.service.impl.PersonnelResumeServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2025/2/17 14:40
 * @Description:
 * @Version 1.0
 */
public class PersonnelResumeAction {

    private PersonnelResumeService getService(User user) {
        return  ServiceUtil.getService(PersonnelResumeServiceImpl.class, user);
    }

    @GET
    @Path("/getResumeList")
    @Produces(MediaType.TEXT_PLAIN)
    public String getResumeList(@Context HttpServletRequest request, @Context HttpServletResponse response, @QueryParam("resourceId") String resourceId){
        Map<String, Object> data = new HashMap<>(8);
        try {
            User user = HrmUserVarify.getUser(request, response);
            data.put("resumeList",getService(user).getResumeList(resourceId));
            data.put("api_status", true);
        } catch (Exception e) {
            data.put("api_status", false);
            data.put("msg", "catch exception : " + e.getMessage());
        }
        return JSONObject.toJSONString(data, SerializerFeature.DisableCircularReferenceDetect);
    }
}
