package weaver.formmode.customjavacode.modeexpand;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.engine.common.util.ServiceUtil;
import com.engine.wysecond.entity.ResourcesPo;
import com.engine.wysecond.service.PostionMatrixService;
import com.engine.wysecond.service.ResourceCardService;
import com.engine.wysecond.service.impl.PostionMatrixServiceImpl;
import com.engine.wysecond.service.impl.ResourceCardServiceImpl;
import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.soa.workflow.request.RequestInfo;

/**
 * @Author liang.cheng
 * @Date 2025/2/28 17:44
 * @Description: 建模卡片按钮扩展
 * @Version 1.0
 */
public class PostionModeExpand extends AbstractModeExpandJavaCodeNew {

    private ResourceCardService getCardService(User user) {
        return  ServiceUtil.getService(ResourceCardServiceImpl.class, user);
    }

    private PostionMatrixService getMatrixService(User user) {
        return  ServiceUtil.getService(PostionMatrixServiceImpl.class, user);
    }

    @Override
    public Map<String, String> doModeExpand(Map<String, Object> param) {
        Map<String, String> result = new HashMap<>();
        try {
            User user = (User)param.get("user");
            RecordSet rs = new RecordSet();
            RequestInfo requestInfo = (RequestInfo)param.get("RequestInfo");
            if(requestInfo != null){
                int billid = Util.getIntValue(requestInfo.getRequestid());
                int modeid = Util.getIntValue(requestInfo.getWorkflowid());
                if(billid > 0 && modeid > 0){
                    rs.executeQuery("select xm from uf_ywzwxx where id = ?",billid);
                    rs.next();
                    String xm = Util.null2String(rs.getString("xm"));

                    String sql = "select id,xm,ywzwxl,ywzwcj,rbywzwcjqssj from uf_ywzwxx where rbywzwcjqssj is not null and xm = ?";
                    rs.executeQuery(sql,xm);
                    List<ResourcesPo> resourcesList = new ArrayList<>();
                    while (rs.next()) {
                        resourcesList.add(ResourcesPo.builder()
                                .id(Util.getIntValue(rs.getString("id")))
                                .resourceId(Util.null2String(rs.getString("xm")))
                                .postionType(Util.null2String(rs.getString("ywzwxl")))
                                .postion(Util.null2String(rs.getString("ywzwcj")))
                                .workDate(Util.null2String(rs.getString("rbywzwcjqssj")))
                                .build());
                    }

                    List<ResourcesPo> resourcesPos = getMatrixService(user).filterClosestWorkDate(resourcesList);

                    //更新
                    getCardService(user).upDateCard(resourcesPos);
                }
            }
        } catch (Exception e) {
            result.put("errmsg","业务职务信息更新人员卡片失败");
            result.put("flag", "false");
        }
        return result;
    }
}
